<template>
  <div
    id="header"
    class="flex flex-row justify-between items-center py-[14px] gap-[35px] bg-background3 acc-info common-mobile-header"
    :class="[
      themeColor.Text === 'bk8' && 'bd-bottom',
      isPlayful ? 'px-2' : 'px-4',
    ]"
  >
    <button v-if="isShowBtn" type="button" class="tc-3" @click="onGoBack">
      <IconChevronLeft class="w-6 h-6 tc-3" />
    </button>
    <span
      class="h-[19px] font-bold text-[16px] leading-[19px] fc-text4 wallet-title m-header-title flex justify-center"
    >
      {{ $t(title) }}
    </span>
    <div
      class="relative menu-right"
      :class="isStyleThree ? 'w-4 h-4' : 'w-6 h-6'"
    >
      <theme-desktop-global-components-menu-drawer v-if="isPlayful" />
      <utils-mobile-tiny-user-center v-else-if="allowCompany && isStyleTwo" />
      <m-header-style-module-tiny-hamburger
        v-else-if="allowCompany && isStyleThree"
        :is-user-center="true"
      />
      <new-black-theme-hamburger-menu v-else />
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, toRefs } from "vue";
import useOnBack from "@/composables/useOnBack";
import { store } from "@/store";
import IconChevronLeft from "~/assets/icons/chevron-left.svg?component";
import { appNavigationStore } from "~~/store/app-navigation";
import EnumMutation from "~~/models/enums/enumMutation";

export default defineComponent({
  components: { IconChevronLeft },
  props: {
    title: {
      type: String,
      required: true,
    },
    isShowBtn: {
      type: Boolean,
      default: true,
    },
    backTo: {
      type: String,
      default: null,
    },
  },
  setup(props) {
    const { previousRoute } = useOnBack();
    const route = useRoute();
    const { themeColor } = themePropertyHelper;
    const router = useRouter();
    const { name } = toRefs(route);
    const isAccount = computed(() => name.value === "Profile");
    const isPlayful = computed(() =>
      ["playful", "global"].includes(store.state.selectedThemeName)
    );
    const backRoute = computed(() =>
      previousRoute.value === "" ? "index" : "Profile"
    );
    const getBackToUrl = computed(() => {
      const backTo = appNavigationStore.state.backToRoute;
      if (backTo) return backTo;
      return "/";
    });
    const onGoBack = () => {
      const isLayoutV2 =
        document.body.hasAttribute("layout-version") &&
        document.body.getAttribute("layout-version") === "2";
      if (isLayoutV2) {
        if (String(route.matched[0].name).includes("help-center")) {
          return router.go(-1);
        }
        router.push(getBackToUrl.value);

        // Reset BackToRoute to default homepage when click on back
        appNavigationStore.commit(
          EnumMutation.updateAppNavigationBackToRoute,
          "/"
        );

        return;
      }
      if (["playful", "global"].includes(store.state.selectedThemeName)) {
        if (String(route.matched[0].name).includes("help-center")) {
          return router.go(-1);
        }
        if (!useIsDesktop()) {
          return router.push({ name: "profile" });
        }
        window.location.href = window.location.origin;
        return;
      }
      if (!String(route.matched[0].name).includes("help-center")) {
        router.push({ name: backRoute.value });
      } else {
        router.go(-1);
      }
    };
    const { isStyleTwo, isStyleThree } = useHeaderRender();
    const { allowCompany } = commonHelper;
    return {
      isAccount,
      onGoBack,
      previousRoute,
      backRoute,
      themeColor,
      isPlayful,
      isStyleTwo,
      isStyleThree,
      allowCompany,
    };
  },
});
</script>

<style lang="scss">
.bd-bottom {
  border-bottom: 1px solid var(--background4);
}
#header .menu-btn {
  padding: 0;
  background: none;
  &::before {
    top: 1px;
    right: 5px;
  }
  svg {
    fill: var(--text3);
  }
}
#header .menu-btn.close-btn {
  background: linear-gradient(
    0deg,
    rgba(var(--bg-light-overlay), var(--bg-opacity)),
    rgba(var(--bg-light-overlay), var(--bg-opacity))
  ),
  linear-gradient(0deg, var(--bg-base-color), var(--bg-base-color));
  padding: 4px;

  svg {
    fill: var(--text5);
  }
}
.transaction-page .common-global {
  .acc-info {
    position: fixed;
    width: 100%;
    z-index: 99;
  }

  .demo-tabs {
    position: fixed;
    top: 52px;
    width: 100%;
    z-index: 99;
  }
}
</style>
<style scoped lang="scss">
[theme-color="global_light_01"] .svg-inline--fa,
.wallet-title {
  color: var(--text3) !important;
}
</style>
